#version 150

in vec3 Position;
in vec4 Color;

uniform mat4 ModelViewMat;
uniform vec2 ScreenSize;
uniform mat4 ProjMat;

out vec4 vertexColor;

void main() {
    gl_Position = ProjMat * ModelViewMat * vec4(Position, 1.0);
	float gui_scale = ProjMat[0][0] * ScreenSize.x * 0.5;
	vec2 xy = gl_Position.xy * ScreenSize * 0.5 / gui_scale;
	xy = vec2(round(xy.x), round(xy.y));
	if (
		xy.x > 0.0 && Color.r == Color.g && Color.r > 0.5 &&
		(
			xy.y == 31.0 || xy.y == 47.0 || xy.y == 49.0 || xy.y == 65.0 ||
			xy == vec2( 66.0, 39.0) || xy == vec2( 66.0, 55.0) ||
			xy == vec2( 82.0, 39.0) || xy == vec2( 82.0, 55.0) ||
			xy == vec2(143.0, 39.0) || xy == vec2(143.0, 55.0) ||
			xy == vec2(159.0, 39.0) || xy == vec2(159.0, 55.0)
		)
	) gl_Position += vec4(2.0, 2.0, 0.0, 0.0);

    vertexColor = Color;
}
