# Throw error if the Nexus is not installed properly

execute store result score #module_count nexus.value if data storage nexus:data modules[{id:"doms_nexus"}]
execute unless score #module_count nexus.value matches 1 run scoreboard players set #doms_nexus_error_boolean nexus.value 1
execute if score #module_count nexus.value matches 000 run tellraw @a ["",{"text":"[","color":"gray","type":"text"},{"text":"Gladiator Games","color":"gold","type":"text"},{"text":"]","color":"gray","type":"text"}," ",{"text":"Error: ","color":"dark_red","type":"text"},{"text":"Dom's Nexus","color":"blue","underlined":true,"hoverEvent":{"action":"show_text","value":[{"text":"Dom's Nexus","color":"blue"},{"text":" on ","color":"gray"},{"text":"GitHub","color":"blue"}]},"clickEvent":{"action":"open_url","value":"https://github.com/Dominexis/Doms-Nexus/releases"},"type":"text"},{"text":" is not installed.","color":"red","type":"text"}]
execute if score #module_count nexus.value matches 2.. run tellraw @a ["",{"text":"[","color":"gray","type":"text"},{"text":"Gladiator Games","color":"gold","type":"text"},{"text":"]","color":"gray","type":"text"}," ",{"text":"Error: ","color":"dark_red","type":"text"},{"text":"Multiple copies of ","color":"red","type":"text"},{"text":"Dom's Nexus","color":"blue","type":"text"},{"text":" exist. Remove all outdated versions.","color":"red","type":"text"}]

scoreboard players set #expected_major nexus.value 2
scoreboard players set #expected_minor nexus.value 1
scoreboard players set #expected_patch nexus.value 0
scoreboard players set #installed_major nexus.value 0
scoreboard players set #installed_minor nexus.value 0
scoreboard players set #installed_patch nexus.value 0

execute if score #module_count nexus.value matches 001 store result score #installed_major nexus.value run data get storage nexus:data modules[{id:"doms_nexus"}].version.major
execute if score #module_count nexus.value matches 001 store result score #installed_minor nexus.value run data get storage nexus:data modules[{id:"doms_nexus"}].version.minor
execute if score #module_count nexus.value matches 001 store result score #installed_patch nexus.value run data get storage nexus:data modules[{id:"doms_nexus"}].version.patch
execute if score #module_count nexus.value matches 001 unless score #installed_major nexus.value = #expected_major nexus.value run scoreboard players set #doms_nexus_error_boolean nexus.value 1
execute if score #module_count nexus.value matches 001 if score #installed_major nexus.value < #expected_major nexus.value run tellraw @a ["",{"text":"[","color":"gray","type":"text"},{"text":"Gladiator Games","color":"gold","type":"text"},{"text":"]","color":"gray","type":"text"}," ",{"text":"Error: ","color":"dark_red","type":"text"},{"text":"Dom's Nexus","color":"blue","underlined":true,"hoverEvent":{"action":"show_text","value":[{"text":"Dom's Nexus","color":"blue"},{"text":" on ","color":"gray"},{"text":"GitHub","color":"blue"}]},"clickEvent":{"action":"open_url","value":"https://github.com/Dominexis/Doms-Nexus/releases"},"type":"text"}," ",{"score":{"name":"#installed_major","objective":"nexus.value"},"color":"gold","type":"score"},{"text":".x.x","color":"gold","type":"text"},{"text":" is too old, update it to the latest version.","color":"red","type":"text"}]
execute if score #module_count nexus.value matches 001 if score #installed_major nexus.value > #expected_major nexus.value run tellraw @a ["",{"text":"[","color":"gray","type":"text"},{"text":"Gladiator Games","color":"gold","type":"text"},{"text":"]","color":"gray","type":"text"}," ",{"text":"Error: ","color":"dark_red","type":"text"},{"text":"Dom's Nexus","color":"blue","type":"text"}," ",{"score":{"name":"#installed_major","objective":"nexus.value"},"color":"gold","type":"score"},{"text":".x.x","color":"gold","type":"text"},{"text":" is too new, update ","color":"red","type":"text"},{"text":"Gladiator Games","color":"gold","underlined":true,"hoverEvent":{"action":"show_text","value":[{"text":"Gladiator Games","color":"gold"},{"text":" on ","color":"gray"},{"text":"GitHub","color":"blue"}]},"clickEvent":{"action":"open_url","value":"https://github.com/Dominexis/Template-Module/releases"},"type":"text"},{"text":" to the latest version.","color":"red","type":"text"}]
execute if score #module_count nexus.value matches 001 if score #installed_major nexus.value = #expected_major nexus.value unless score #installed_minor nexus.value = #expected_minor nexus.value run scoreboard players set #doms_nexus_error_boolean nexus.value 1
execute if score #module_count nexus.value matches 001 if score #installed_major nexus.value = #expected_major nexus.value if score #installed_minor nexus.value < #expected_minor nexus.value run tellraw @a ["",{"text":"[","color":"gray","type":"text"},{"text":"Gladiator Games","color":"gold","type":"text"},{"text":"]","color":"gray","type":"text"}," ",{"text":"Error: ","color":"dark_red","type":"text"},{"text":"Dom's Nexus","color":"blue","underlined":true,"hoverEvent":{"action":"show_text","value":[{"text":"Dom's Nexus","color":"blue"},{"text":" on ","color":"gray"},{"text":"GitHub","color":"blue"}]},"clickEvent":{"action":"open_url","value":"https://github.com/Dominexis/Doms-Nexus/releases"},"type":"text"}," ",{"score":{"name":"#installed_major","objective":"nexus.value"},"color":"gold","type":"score"},{"text":".","color":"gold","type":"text"},{"score":{"name":"#installed_minor","objective":"nexus.value"},"color":"gold","type":"score"},{"text":".x","color":"gold","type":"text"},{"text":" is too old, update it to the latest version.","color":"red","type":"text"}]
execute if score #module_count nexus.value matches 001 if score #installed_major nexus.value = #expected_major nexus.value if score #installed_minor nexus.value > #expected_minor nexus.value run tellraw @a ["",{"text":"[","color":"gray","type":"text"},{"text":"Gladiator Games","color":"gold","type":"text"},{"text":"]","color":"gray","type":"text"}," ",{"text":"Error: ","color":"dark_red","type":"text"},{"text":"Dom's Nexus","color":"blue","type":"text"}," ",{"score":{"name":"#installed_major","objective":"nexus.value"},"color":"gold","type":"score"},{"text":".","color":"gold","type":"text"},{"score":{"name":"#installed_minor","objective":"nexus.value"},"color":"gold","type":"score"},{"text":".x","color":"gold","type":"text"},{"text":" is too new, update ","color":"red","type":"text"},{"text":"Gladiator Games","color":"gold","underlined":true,"hoverEvent":{"action":"show_text","value":[{"text":"Gladiator Games","color":"gold"},{"text":" on ","color":"gray"},{"text":"GitHub","color":"blue"}]},"clickEvent":{"action":"open_url","value":"https://github.com/Dominexis/Template-Module/releases"},"type":"text"},{"text":" to the latest version.","color":"red","type":"text"}]
execute if score #module_count nexus.value matches 001 if score #installed_major nexus.value = #expected_major nexus.value if score #installed_minor nexus.value = #expected_minor nexus.value unless score #installed_patch nexus.value >= #expected_patch nexus.value run scoreboard players set #doms_nexus_error_boolean nexus.value 1
execute if score #module_count nexus.value matches 001 if score #installed_major nexus.value = #expected_major nexus.value if score #installed_minor nexus.value = #expected_minor nexus.value if score #installed_patch nexus.value < #expected_patch nexus.value run tellraw @a ["",{"text":"[","color":"gray","type":"text"},{"text":"Gladiator Games","color":"gold","type":"text"},{"text":"]","color":"gray","type":"text"}," ",{"text":"Error: ","color":"dark_red","type":"text"},{"text":"Dom's Nexus","color":"blue","underlined":true,"hoverEvent":{"action":"show_text","value":[{"text":"Dom's Nexus","color":"blue"},{"text":" on ","color":"gray"},{"text":"GitHub","color":"blue"}]},"clickEvent":{"action":"open_url","value":"https://github.com/Dominexis/Doms-Nexus/releases"},"type":"text"}," ",{"score":{"name":"#installed_major","objective":"nexus.value"},"color":"gold","type":"score"},{"text":".","color":"gold","type":"text"},{"score":{"name":"#installed_minor","objective":"nexus.value"},"color":"gold","type":"score"},{"text":".","color":"gold","type":"text"},{"score":{"name":"#installed_patch","objective":"nexus.value"},"color":"gold","type":"score"},{"text":" is too old, update it to the latest version.","color":"red","type":"text"}]







# Throw error if the Database Library is not installed properly

execute store result score #module_count nexus.value if data storage nexus:data modules[{id:"database_library"}]
execute unless score #module_count nexus.value matches 1 run scoreboard players set #doms_nexus_error_boolean nexus.value 1
execute if score #module_count nexus.value matches 000 run tellraw @a ["",{"text":"[","color":"gray","type":"text"},{"text":"Gladiator Games","color":"gold","type":"text"},{"text":"]","color":"gray","type":"text"}," ",{"text":"Error: ","color":"dark_red","type":"text"},{"text":"Database Library","color":"gold","underlined":true,"hoverEvent":{"action":"show_text","value":[{"text":"Database Library","color":"gold"},{"text":" on ","color":"gray"},{"text":"GitHub","color":"blue"}]},"clickEvent":{"action":"open_url","value":"https://github.com/Dominexis/Database-Library/releases"},"type":"text"},{"text":" is not installed.","color":"red","type":"text"}]
execute if score #module_count nexus.value matches 2.. run tellraw @a ["",{"text":"[","color":"gray","type":"text"},{"text":"Gladiator Games","color":"gold","type":"text"},{"text":"]","color":"gray","type":"text"}," ",{"text":"Error: ","color":"dark_red","type":"text"},{"text":"Multiple copies of ","color":"red","type":"text"},{"text":"Database Library","color":"gold","type":"text"},{"text":" exist. Remove all outdated versions.","color":"red","type":"text"}]

scoreboard players set #expected_major nexus.value 1
scoreboard players set #expected_minor nexus.value 3
scoreboard players set #expected_patch nexus.value 0
scoreboard players set #installed_major nexus.value 0
scoreboard players set #installed_minor nexus.value 0
scoreboard players set #installed_patch nexus.value 0

execute if score #module_count nexus.value matches 001 store result score #installed_major nexus.value run data get storage nexus:data modules[{id:"database_library"}].version.major
execute if score #module_count nexus.value matches 001 store result score #installed_minor nexus.value run data get storage nexus:data modules[{id:"database_library"}].version.minor
execute if score #module_count nexus.value matches 001 store result score #installed_patch nexus.value run data get storage nexus:data modules[{id:"database_library"}].version.patch
execute if score #module_count nexus.value matches 001 unless score #installed_major nexus.value = #expected_major nexus.value run scoreboard players set #doms_nexus_error_boolean nexus.value 1
execute if score #module_count nexus.value matches 001 if score #installed_major nexus.value < #expected_major nexus.value run tellraw @a ["",{"text":"[","color":"gray","type":"text"},{"text":"Gladiator Games","color":"gold","type":"text"},{"text":"]","color":"gray","type":"text"}," ",{"text":"Error: ","color":"dark_red","type":"text"},{"text":"Database Library","color":"gold","underlined":true,"hoverEvent":{"action":"show_text","value":[{"text":"Database Library","color":"gold"},{"text":" on ","color":"gray"},{"text":"GitHub","color":"blue"}]},"clickEvent":{"action":"open_url","value":"https://github.com/Dominexis/Database-Library/releases"},"type":"text"}," ",{"score":{"name":"#installed_major","objective":"nexus.value"},"color":"gold","type":"score"},{"text":".x.x","color":"gold","type":"text"},{"text":" is too old, update it to the latest version.","color":"red","type":"text"}]
execute if score #module_count nexus.value matches 001 if score #installed_major nexus.value > #expected_major nexus.value run tellraw @a ["",{"text":"[","color":"gray","type":"text"},{"text":"Gladiator Games","color":"gold","type":"text"},{"text":"]","color":"gray","type":"text"}," ",{"text":"Error: ","color":"dark_red","type":"text"},{"text":"Database Library","color":"gold","type":"text"}," ",{"score":{"name":"#installed_major","objective":"nexus.value"},"color":"gold","type":"score"},{"text":".x.x","color":"gold","type":"text"},{"text":" is too new, update ","color":"red","type":"text"},{"text":"Gladiator Games","color":"gold","underlined":true,"hoverEvent":{"action":"show_text","value":[{"text":"Gladiator Games","color":"gold"},{"text":" on ","color":"gray"},{"text":"GitHub","color":"blue"}]},"clickEvent":{"action":"open_url","value":"https://github.com/Dominexis/Template-Module/releases"},"type":"text"},{"text":" to the latest version.","color":"red","type":"text"}]
execute if score #module_count nexus.value matches 001 if score #installed_major nexus.value = #expected_major nexus.value unless score #installed_minor nexus.value = #expected_minor nexus.value run scoreboard players set #doms_nexus_error_boolean nexus.value 1
execute if score #module_count nexus.value matches 001 if score #installed_major nexus.value = #expected_major nexus.value if score #installed_minor nexus.value < #expected_minor nexus.value run tellraw @a ["",{"text":"[","color":"gray","type":"text"},{"text":"Gladiator Games","color":"gold","type":"text"},{"text":"]","color":"gray","type":"text"}," ",{"text":"Error: ","color":"dark_red","type":"text"},{"text":"Database Library","color":"gold","underlined":true,"hoverEvent":{"action":"show_text","value":[{"text":"Database Library","color":"gold"},{"text":" on ","color":"gray"},{"text":"GitHub","color":"blue"}]},"clickEvent":{"action":"open_url","value":"https://github.com/Dominexis/Database-Library/releases"},"type":"text"}," ",{"score":{"name":"#installed_major","objective":"nexus.value"},"color":"gold","type":"score"},{"text":".","color":"gold","type":"text"},{"score":{"name":"#installed_minor","objective":"nexus.value"},"color":"gold","type":"score"},{"text":".x","color":"gold","type":"text"},{"text":" is too old, update it to the latest version.","color":"red","type":"text"}]
execute if score #module_count nexus.value matches 001 if score #installed_major nexus.value = #expected_major nexus.value if score #installed_minor nexus.value > #expected_minor nexus.value run tellraw @a ["",{"text":"[","color":"gray","type":"text"},{"text":"Gladiator Games","color":"gold","type":"text"},{"text":"]","color":"gray","type":"text"}," ",{"text":"Error: ","color":"dark_red","type":"text"},{"text":"Database Library","color":"gold","type":"text"}," ",{"score":{"name":"#installed_major","objective":"nexus.value"},"color":"gold","type":"score"},{"text":".","color":"gold","type":"text"},{"score":{"name":"#installed_minor","objective":"nexus.value"},"color":"gold","type":"score"},{"text":".x","color":"gold","type":"text"},{"text":" is too new, update ","color":"red","type":"text"},{"text":"Gladiator Games","color":"gold","underlined":true,"hoverEvent":{"action":"show_text","value":[{"text":"Gladiator Games","color":"gold"},{"text":" on ","color":"gray"},{"text":"GitHub","color":"blue"}]},"clickEvent":{"action":"open_url","value":"https://github.com/Dominexis/Template-Module/releases"},"type":"text"},{"text":" to the latest version.","color":"red","type":"text"}]
execute if score #module_count nexus.value matches 001 if score #installed_major nexus.value = #expected_major nexus.value if score #installed_minor nexus.value = #expected_minor nexus.value unless score #installed_patch nexus.value >= #expected_patch nexus.value run scoreboard players set #doms_nexus_error_boolean nexus.value 1
execute if score #module_count nexus.value matches 001 if score #installed_major nexus.value = #expected_major nexus.value if score #installed_minor nexus.value = #expected_minor nexus.value if score #installed_patch nexus.value < #expected_patch nexus.value run tellraw @a ["",{"text":"[","color":"gray","type":"text"},{"text":"Gladiator Games","color":"gold","type":"text"},{"text":"]","color":"gray","type":"text"}," ",{"text":"Error: ","color":"dark_red","type":"text"},{"text":"Database Library","color":"gold","underlined":true,"hoverEvent":{"action":"show_text","value":[{"text":"Database Library","color":"gold"},{"text":" on ","color":"gray"},{"text":"GitHub","color":"blue"}]},"clickEvent":{"action":"open_url","value":"https://github.com/Dominexis/Database-Library/releases"},"type":"text"}," ",{"score":{"name":"#installed_major","objective":"nexus.value"},"color":"gold","type":"score"},{"text":".","color":"gold","type":"text"},{"score":{"name":"#installed_minor","objective":"nexus.value"},"color":"gold","type":"score"},{"text":".","color":"gold","type":"text"},{"score":{"name":"#installed_patch","objective":"nexus.value"},"color":"gold","type":"score"},{"text":" is too old, update it to the latest version.","color":"red","type":"text"}]







# Throw error if multiple copies of the module are loaded

execute store result score #module_count nexus.value if data storage nexus:data modules[{id:"gladiator_games"}]
execute if score #module_count nexus.value matches 2.. run scoreboard players set #doms_nexus_error_boolean nexus.value 1
execute if score #module_count nexus.value matches 2.. run tellraw @a ["",{"text":"[","color":"gray","type":"text"},{"text":"Gladiator Games","color":"gold","type":"text"},{"text":"]","color":"gray","type":"text"}," ",{"text":"Error: ","color":"dark_red","type":"text"},{"text":"Multiple copies of ","color":"red","type":"text"},{"text":"Gladiator Games","color":"gold","type":"text"},{"text":" exist. Remove all outdated versions.","color":"red","type":"text"}]